package com.divillysausages.connected.logic 
{
	import com.divillysausages.ds.DS;
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	/**
	 * ...
	 * @author Damian Connolly
	 */
	public class Star extends SpaceItem
	{
		
		/*******************************************************************************************/
		
		private static const M_STAR_BMD:BitmapData = new BitmapData( 6, 6, true, 0x7fffffff );
		
		/*******************************************************************************************/
		
		private var m_rotDir:int 		= 0;
		private var m_rotSpeed:Number	= 0.0;
		
		/*******************************************************************************************/
		
		override public function set scale(n:Number):void 
		{
			super.scale = ( n < 0.5 ) ? 0.5 : n;
		}
		
		/*******************************************************************************************/
		
		public function Star( ship:Ship ) 
		{
			super( ship );
			
			this.zPos 		= Math.random() * SpaceItem.MAX_DIST;
			this.m_rotDir	= ( Math.random() < 0.5 ) ? -1 : 1;
			this.m_rotSpeed	= 20 + Math.random() + 20.0;
			
			var b:Bitmap 	= new Bitmap( Star.M_STAR_BMD );
			b.x				= -b.width;
			b.y				= -b.height;
			this.addChild( b );
			
			this.x = -DS.stage.stageWidth + Math.random() * DS.stage.stageWidth * 2.0;
			this.y = -DS.stage.stageHeight + Math.random() * DS.stage.stageHeight * 2.0;
		}
		
		override public function reset():void 
		{
			super.reset();
			
			this.x = -DS.stage.stageWidth + Math.random() * DS.stage.stageWidth * 2.0;
			this.y = -DS.stage.stageHeight + Math.random() * DS.stage.stageHeight * 2.0;
		}
		
		override public function update( dt:Number ):void
		{				
			super.update( dt );
			this.rotation += this.m_rotDir * this.m_rotSpeed * dt;
		}
		
	}

}